<?php
class MySiteMap extends plxPlugin {
 
    public function __construct($default_lang){
    # Appel du constructeur de la classe plxPlugin (obligatoire)
    parent::__construct($default_lang);
    
    # Pour accéder à une page de configuration
    $this->setConfigProfil(PROFIL_ADMIN,PROFIL_MANAGER);
    # Déclaration des hooks


    $this->addHook('plxShowConstruct', 'plxShowConstruct');
    $this->addHook('plxMotorPreChauffageBegin', 'plxMotorPreChauffageBegin');
    $this->addHook('plxShowStaticListEnd', 'plxShowStaticListEnd');
    $this->addHook('plxShowPageTitle', 'plxShowPageTitle');
    $this->addHook('SitemapStatics', 'SitemapStatics');
    $this->addHook('MySiteMap', 'MySiteMap');
    } 

    public function MySiteMap(){

        $info = $this->getParam('mnuInfo');

        if(!empty($info)){
                echo '<p>'. $info .'</p>';//info haut de page
            }
            global $plxShow;

            # format de la date
            $format_date = '#num_day/#num_month/#num_year(4)';
             
            # liste des catégories à afficher
            # exemple: $catList = ''; = articles de toutes les catégories, 
            # exemple: $catList = '001|003'; = articles des catégories 001 et 003 uniquement
            $catList = ''; 
            # nombre d'articles à afficher par catégorie, mettre 0 pour lister tous les articles
            $artsByCategory = 0; 
            #==========================

            $mnuDisplay = $this->getParam('mnuDisplay');
            $pagestatic =  $this->getParam('pagestatic');
            $category   =  $this->getParam('category');


            if ($pagestatic == '1') { ?>
                <h3>Pages statiques</h3>
                <ul>
                    <?php $plxShow->staticList('Accueil','<li id="#static_id"><a href="#static_url" class="#static_status" title="#static_name">#static_name</a></li>'); ?>
                </ul>
             <?php } 
             if ($category == '1') { ?>
                <h3>Catégories</h3>
                <ul>
                    <?php $plxShow->catList('','<li id="#cat_id" class="#cat_status"><a href="#cat_url" title="#cat_name">#cat_name</a></li>'); ?>
                </ul>
             <?php } ?>

            <h3>Articles</h3>
            <?php
            $plx_arts = array();
            $plxGlob_arts = plxGlob::getInstance(PLX_ROOT.$plxShow->plxMotor->aConf['racine_articles']);
            $aFiles = $plxGlob_arts->query('/[0-9]{4}.[home|0-9,]*'.$catList.'[0-9,]*.[0-9]{3}.[0-9]{12}.[a-z0-9-]+.xml$/','art','rsort',0,false,'before');
            $aCatList = explode('|', $catList);
            if(is_array($aFiles)) { # On a des fichiers
                foreach($aFiles as $k=> $v) { # On parcourt tous les fichiers
                    $temp = $plxShow->plxMotor->parseArticle(PLX_ROOT.$plxShow->plxMotor->aConf['racine_articles'].$v);
                    $cats = explode(',', $temp['categorie']);
                    foreach($cats as $cat) {
                        if($catList=='' OR in_array($cat, $aCatList)) {
                            if(!isset($plx_arts[$cat]))
                                $plx_arts[$cat][] = $temp;
                            elseif(intval(sizeof($plx_arts[$cat])) < $artsByCategory OR $artsByCategory == 0)
                                $plx_arts[$cat][] = $temp;
                        }
                    }
                }
                if($plx_arts) { # On a des articles
                    
                    # tri en fonction de l'ordre d'affiche des catégories
                    uksort($plx_arts, function($a, $b){
                        global $plxShow; 
                        return strcmp(
                        array_search($a, 
                            array_keys($plxShow->plxMotor->aCats)), 
                            array_search($b, 
                                array_keys($plxShow->plxMotor->aCats))
                            )
                                ;});
                        
                    # On boucle sur nos articles
                    foreach ($plx_arts as $k => $v) {

                        $cat_num = $k;
                    
                        # on trie en fonction de l'ordre d'affichage des articles dans la catégorie
                        if($cat_num=='home') {
                            if ($plxShow->plxMotor->aConf['tri']=='asc') 
                                usort($v, function($a, $b){return strcmp($a["date"], $b["date"]);});
                            else
                                usort($v, function($a, $b){return strcmp($b["date"], $a["date"]);});
                            echo '<h5><a href="'.$plxShow->plxMotor->aConf['racine'].'">Accueil</a></h5>';
                        }
                        elseif(!isset($plxShow->plxMotor->aCats[$cat_num])) {
                            if ($plxShow->plxMotor->aConf['tri']=='asc') 
                                usort($v, function($a, $b){return strcmp($a["date"], $b["date"]);});
                            else
                                usort($v, function($a, $b){return strcmp($b["date"], $a["date"]);});
                            $cat_name ='Non classé';
                        } 
                        else {
                            if ($plxShow->plxMotor->aCats[$cat_num]['tri'] == 'asc')
                                usort($v, function($a, $b){return strcmp($a["date"], $b["date"]);});
                            else
                                usort($v, function($a, $b){return strcmp($b["date"], $a["date"]);});
                            $cat_name = plxUtils::strCheck($plxShow->plxMotor->aCats[ $cat_num ]['name']);
                            $cat_url = $plxShow->plxMotor->aCats[ $cat_num ]['url'];
                            echo '';                
                        }
                        echo "<h5>".$cat_name."</h5><ul class='alt'>";
                        # On boucle sur les articles de la categories
                        foreach($v as $null => $art ){
                            $art_num = intval($art['numero']);
                            $art_url = plxUtils::strCheck(($art['url']));
                            $art_title = plxUtils::strCheck(($art['title']));
                            $art_date = plxDate::formatDate($art['date'], $format_date);
                            echo '<li>'.$art_date.' : <a href="'.$plxShow->plxMotor->aConf['racine'].'?article'.$art_num.'/'.$art_url.'">'.$art_title.'</a></li>'; 
                        }
                        echo "</ul>";
                    }

                }
            }
    }

    public function plxShowConstruct() {
        # infos sur la page statique
        $string  = "if(\$this->plxMotor->mode=='sitemap') {";
        $string .= "    \$array = array();";
        $string .= "    \$array[\$this->plxMotor->cible] = array(
            'name'      => '".addslashes($this->getParam('mnuName'))."',
            'menu'      => '',
            'url'       => 'sitemap',
            'readable'  => 1,
            'active'    => 1,
            'group'     => ''
        );";
        $string .= "    \$this->plxMotor->aStats = array_merge(\$this->plxMotor->aStats, \$array);";
        $string .= "}";
        echo "<?php ".$string." ?>";
    }

    public function plxMotorPreChauffageBegin() {
        $template = $this->getParam('template')==''?'static.php':$this->getParam('template');
        $string = "
        if(\$this->get && preg_match('/^sitemap\/?/',\$this->get)) {
            \$this->mode = 'sitemap';
            \$this->cible = '../../plugins/MySiteMap/static';
            \$this->template = '".$template."';
            return true;
        }
        ";
        echo "<?php ".$string." ?>";
    }

    public function plxShowStaticListEnd() {
        # ajout du menu pour accèder à la page de MyTeam
        if($this->getParam('mnuDisplay')) {
            echo "<?php \$class = \$this->plxMotor->mode=='sitemap'?'active':'noactive'; ?>";
            echo "<?php array_splice(\$menus, ".($this->getParam('mnuPos')-1).", 0, '<li><a class=\"static '.\$class.'\" href=\"'.\$this->plxMotor->urlRewrite('?sitemap').'\">".$this->getParam('mnuName')."</a></li>'); ?>";
        }
    }

    public function plxShowPageTitle() {
        echo '<?php
            if($this->plxMotor->mode == "sitemap") {
                echo plxUtils::strCheck($this->plxMotor->aConf["title"]." - '.$this->getParam('mnuName').'");
                return true;
            }
        ?>';
    }

    public function SitemapStatics() {
        echo '<?php
        echo "\n";
        echo "\t<url>\n";
        echo "\t\t<loc>".$plxMotor->urlRewrite("?sitemap")."</loc>\n";
        echo "\t\t<changefreq>monthly</changefreq>\n";
        echo "\t\t<priority>0.8</priority>\n";
        echo "\t</url>\n";
        ?>';
    }

} // class MySiteMap
?>
